﻿using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Windows;
using Infragistics.Controls.Charts;

namespace WpfApp1
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();

            var p = new Point(-105.517363, 44.287229);
            var rect = new Rect(p, new Size(0.01, 0.01));

            var pl = new PointList
                     {
                         rect.TopLeft,
                         rect.BottomRight,
                         rect.TopRight,
                         rect.BottomLeft
                     };

            var l = new Line
                    {
                        Points = pl
                    };

            var ls = new ObservableCollection<Line>
                     {
                         l
                     };

            WorldRect = rect;
            Lines = ls;
        }

        #region WorldRect Dependency Property

        public static readonly DependencyProperty WorldRectProperty =
            DependencyProperty.Register("WorldRect",
                                        typeof(Rect),
                                        typeof(MainWindow),
                                        new PropertyMetadata(default(Rect)));

        public Rect WorldRect
        {
            get
            {
                Rect res = default(Rect);

                if (CheckAccess() != false)
                {
                    res = (Rect) GetValue(WorldRectProperty);
                }
                else
                {
                    Dispatcher.Invoke(() => res = (Rect) GetValue(WorldRectProperty));
                }

                return res;
            }
            set
            {
                if (CheckAccess() != false)
                {
                    SetValue(WorldRectProperty, value);
                }
                else
                {
                    Dispatcher.Invoke(() => SetValue(WorldRectProperty, value));
                }
            }
        }

        #endregion

        public class Line
        {
            public PointList Points { get; set; }

        }

        #region Lines Dependency Property

        public static readonly DependencyProperty LinesProperty =
            DependencyProperty.Register("Lines",
                                        typeof(ObservableCollection<Line>),
                                        typeof(MainWindow),
                                        new PropertyMetadata(default(ObservableCollection<Line>)));

        public ObservableCollection<Line> Lines
        {
            get
            {
                ObservableCollection<Line> res = default(ObservableCollection<Line>);

                if (CheckAccess() != false)
                {
                    res = (ObservableCollection<Line>) GetValue(LinesProperty);
                }
                else
                {
                    Dispatcher.Invoke(() => res = (ObservableCollection<Line>) GetValue(LinesProperty));
                }

                return res;
            }
            set
            {
                if (CheckAccess() != false)
                {
                    SetValue(LinesProperty, value);
                }
                else
                {
                    Dispatcher.Invoke(() => SetValue(LinesProperty, value));
                }
            }
        }

        #endregion


        private void XamGeographicMap_MouseDoubleClick(object sender, System.Windows.Input.MouseButtonEventArgs e)
        {
            var p = new Point(-105.517363, 44.287229);
            var rect = new Rect(p, new Size(0.01, 0.01));

            var pl = new PointList
                     {
                         rect.TopLeft,
                         rect.TopRight,
                         rect.BottomRight,
                         rect.BottomLeft
                     };

            var l = new Line
                    {
                        Points = pl
                    };

            Lines.Clear();
            Lines.Add(l);

            // potential workaround, 
            // but not suitable for situatiosn where lines collection is bound to readonly collection that can't 
            // be set to null

            //
            //var lc = Lines;
            //Lines = null;

            //lc.Clear();
            //lc.Add(l);

            //Lines = lc;
            //
        }
    }
}
